#include <stdlib.h>
#include <stdio.h>
#include <stdint.h>
#include <conio.h>
#include "wgif.h"

#define WIDTH 32
#define HEIGHT 32

int fwr(uint8_t *ptr, size_t bytes, void *wp) {
    return fwrite(ptr, 1, bytes, wp);
}


int main() {
    uint32_t ct[3];
    struct gif_file gf;
    uint8_t bitmap[WIDTH*HEIGHT];
    int x, y;

    ct[0]=0x00ffff;
    ct[1]=0xcccccc;
    ct[2]=0x000000;

    gf.wr_fnct=fwr;
    gf.wparm=fopen("helloworld.gif", "wb");

    gif_init(&gf, WIDTH, HEIGHT, ct, 3, 0);
    for (y=0;y<HEIGHT;y++) {
        for (x=0;x<WIDTH;x++) {
            if (x<y) {
                bitmap[x+y*WIDTH]=0;
            } else if (x==y) {
                bitmap[x+y*WIDTH]=2;
            } else {
                bitmap[x+y*WIDTH]=1;
            }
        }
    }
    gif_image(&gf, 0, 0, WIDTH, HEIGHT, NULL, 0, bitmap);
    gif_end(&gf);

    fclose(gf.wparm);
    getch();

    return 0;
}